"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let FallbackLocalStorage = require('fallback-local-storage');
let appStorage;
if (FallbackLocalStorage.getStorage().includes('localStorage')) {
    appStorage = localStorage;
}
else {
    appStorage = new FallbackLocalStorage();
}
var LocalStore;
(function (LocalStore) {
    // Auto detect supported storage adapter (default behavior)
    let store = appStorage;
    /**
     * @param {String} key - a key for a stored object
     * @return {Object} a promise for the object at the given key
     */
    LocalStore.getItem = (key) => {
        return new Promise((resolve, reject) => {
            let itemAsString = store.getItem(key);
            try {
                resolve(JSON.parse(itemAsString));
            }
            catch (e) {
                resolve(itemAsString);
            }
        });
    };
    /**
     * @param {String} key - a key for a stored object
     * @param {Object} value - the object to be stored
     * @return {Object} a promise for the object at the given key
     */
    LocalStore.setItem = (key, value) => {
        return new Promise((resolve, reject) => {
            store.setItem(key, JSON.stringify(value));
            resolve(value);
        });
    };
})(LocalStore = exports.LocalStore || (exports.LocalStore = {}));
//# sourceMappingURL=LocalStore.js.map