"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var FireStore = /** @class */ (function () {
    function FireStore(db) {
        this.db = db;
    }
    FireStore.prototype.getItem = function (key) {
        // console.log('getItem deconstruct key to collection + id', key)
        var parts = key.split(':');
        var collectionType = parts[0];
        var docId = parts[1];
        return this.db
            .collection(collectionType)
            .doc(docId)
            .get()
            .then(function (doc) {
            return doc.data();
        })
            .catch(function (err) {
            if (err) {
                console.log('failed to getItem from firestore', err);
            }
            return null;
        });
    };
    FireStore.prototype.setItem = function (key, value) {
        // console.log('setItem deconstruct key to collection + id', key)
        var parts = key.split(':');
        var collectionType = parts[0];
        var docId = parts[1];
        console.log('setting read model');
        if (!_.every(_.map([value.readModelType, value.contractAddress], function (value) {
            return value !== undefined && value !== null && value !== '';
        }))) {
            throw Error('readModel missing readModelType or contractAddress. ' + JSON.stringify(value));
        }
        return this.db.collection(collectionType).doc(docId).set(value).catch(function (err) {
            if (err) {
                console.log('failed to setItem to firestore', err);
            }
            return null;
        });
    };
    return FireStore;
}());
exports.default = FireStore;
//# sourceMappingURL=FireStore.js.map